<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 499.1   Patch: 6                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Users
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function UserDoRecovery
 * A function to recover a password
 * @author Philipp Louis Esselbach
 */
function UserDoRecovery()
{
	global $database, $templates, $security, $system, $preferences, $uwrapper;
	
	if( !preg_match( "/Contentteller/i", $preferences[ 'website_uwrapper_product' ] ) )
	{
		$uwrapper -> usercp();
	}
	
	$input_username = ( isset( $_POST[ 'input_username' ] ) ) ? $security -> checkvar( $_POST[ 'input_username' ] ) : "" ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_verify_password = ( isset( $_POST[ 'input_verify_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_verify_password' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','user_recovery_error_loginname','user_recovery_error_loginnameempty','user_recovery_error_password','user_recovery_error_alreadyqueued','user_recovery_email_subject','user_recovery_email_body','user_recovery_done'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	session_start();
	
	if( ( $_SESSION[ 'user_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		exit;
	}
	
	$error_message = "";
	
	if( $preferences[ 'user_registration_queuehold' ] == 1 )
	{
		$expire_time = 3600;
	}
	elseif( $preferences[ 'user_registration_queuehold' ] == 6 )
	{
		$expire_time = 21600;
	}
	elseif( $preferences[ 'user_registration_queuehold' ] == 12 )
	{
		$expire_time = 43200;
	}
	elseif( $preferences[ 'user_registration_queuehold' ] == 24 )
	{
		$expire_time = 86400;
	}
	elseif( $preferences[ 'user_registration_queuehold' ] == 48 )
	{
		$expire_time = 172800;
	}
	
	$expire_date = mktime() + $expire_time;
	$expire_date = date( "Y-m-d H:i:s", $expire_date );
	$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_usersrecovery WHERE userrecovery_time < ('" . $expire_date . "')" );
	
	if( $input_username )
	{
		$query = $database -> dbquery( "SELECT user_id, user_email FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_loginname = '" . $input_username . "'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $input_id, $input_email ) = $database -> dbrow( $query );
			$query2 = $database -> dbquery( "SELECT userrecovery_id FROM " . DB_PREFIX . "esselbach_ct_usersrecovery WHERE userrecovery_userid = '" . $input_id . "'" );
			
			if( $database -> dbrows( $query2 ) )
			{
				$error_message = $templates -> exectemplate( $main_templates[ 'user_recovery_error_alreadyqueued_html' ], $main_templates[ 'user_recovery_error_alreadyqueued_php' ], $insert );
			}
		}
		else
		{
			$error_message = $templates -> exectemplate( $main_templates[ 'user_recovery_error_loginname_html' ], $main_templates[ 'user_recovery_error_loginname_php' ], $insert );
		}
	}
	else
	{
		$error_message = $templates -> exectemplate( $main_templates[ 'user_recovery_error_loginnameempty_html' ], $main_templates[ 'user_recovery_error_loginnameempty_php' ], $insert );
	}
	
	if( $input_password != $input_verify_password )
	{
		$error_message = $templates -> exectemplate( $main_templates[ 'user_recovery_error_password_html' ], $main_templates[ 'user_recovery_error_password_php' ], $insert );
	}
	
	if( $error_message )
	{
		include( "userrecovery.php" );
		UserRecovery( $error_message );
		exit;
	}
	
	$templates -> initgzip();
	$ipaddr = $system -> getip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	$input_password_hashed = $system -> hashpass( $input_password );
	$input_password_salt = md5( rand( 0, 32768 ) );
	$input_password = $system -> hashpass( $input_password_hashed . $input_password_salt );
	$updatekey = md5( rand( 1, 32768 ) ) . md5( rand( 1, 32768 ) );
	$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_usersrecovery (userrecovery_id, userrecovery_userid, userrecovery_password, userrecovery_salt, userrecovery_time, userrecovery_updatekey, userrecovery_ip) VALUES (NULL, '" . $input_id . "', '" . $input_password . "', '" . $input_password_salt . "', now(), '" . $updatekey . "', '" . $ipaddr . "')" );
	$insert[ 'recovery_username' ] = $input_username;
	$insert[ 'recovery_email' ] = $input_email;
	$insert[ 'recovery_ipaddr' ] = $ipaddr;
	$insert[ 'recovery_url' ] = $insert[ 'site_url' ] . "/contentteller.php?ct=users&action=confirmrecovery&opt=" . $updatekey;
	$insert[ 'recovery_siteadmin' ] = $preferences[ 'user_registration_adminname' ];
	$email_subject = $templates -> exectemplate( $main_templates[ 'user_recovery_email_subject_html' ], $main_templates[ 'user_recovery_email_subject_php' ], $insert );
	$email_body = $templates -> exectemplate( $main_templates[ 'user_recovery_email_body_html' ], $main_templates[ 'user_recovery_email_body_php' ], $insert );
	$email_header = $system -> mailheader( $preferences[ 'user_registration_adminname' ], $preferences[ 'user_registration_adminemail' ], $insert[ 'activation_username' ], $input_email );
		
	if( $preferences[ 'user_registration_emailserver' ] == "SMTP" )
	{
		$system -> smtpmail( $preferences[ 'user_registration_smtphost' ], $preferences[ 'user_registration_smtpport' ], $preferences[ 'user_registration_smtpusername' ], $preferences[ 'user_registration_smtppassword' ], $preferences[ 'user_registration_adminemail' ], $input_email, $email_subject, $email_body, $email_header );
	}
	else
	{
		mail( $input_email, $email_subject, $email_body, $email_header );
	}
	
	echo $templates -> exectemplate( $main_templates[ 'user_recovery_done_html' ], $main_templates[ 'user_recovery_done_php' ], $insert );
	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>